"use strict";

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _ajax = require("./ajax");

var _ajax2 = _interopRequireDefault(_ajax);

var _socket = require("./socket");

var _socket2 = _interopRequireDefault(_socket);

var _formDataNormalizer = require("./form-data-normalizer");

var _formDataNormalizer2 = _interopRequireDefault(_formDataNormalizer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Transport = (function () {
    function Transport() {
        _classCallCheck(this, Transport);
    }

    _createClass(Transport, [{
        key: "_normalizeArgs",
        value: function _normalizeArgs() {
            var option = arguments.length <= 0 ? undefined : arguments[0];
            var normalizedOptions = {
                method: "GET",
                url: "",
                contentType: "application/x-www-form-urlencoded",
                headers: {},
                dataType: null,
                data: null,
                processData: true
            };

            if (arguments.length === 1 && typeof option === "string") {
                normalizedOptions.url = option;
                return normalizedOptions;
            }

            if (normalizedOptions.processData === false) {
                return normalizedOptions;
            }

            if (normalizedOptions.data != null) {
                normalizedOptions.data = _formDataNormalizer2.default.processData(normalizedOptions.data, normalizedOptions.processData);
            }

            if (normalizedOptions.data != null && (normalizedOptions.method === "GET" || normalizedOptions.method === "HEAD")) {
                normalizedOptions.url += "?" + _formDataNormalizer2.default.objectToQueryParameter(normalizedOptions.data);
            }

            return normalizedOptions;
        }
    }, {
        key: "get",
        value: function get() {
            var options = this._normalizeArgs.apply(this, arguments);
            options.method = "get";
            return Transport.ajax(options);
        }
    }, {
        key: "post",
        value: function post() {
            var options = this._normalizeArgs.apply(this, arguments);
            options.method = "post";
            return Transport.ajax(options);
        }
    }, {
        key: "delete",
        value: function _delete() {
            var options = this._normalizeArgs.apply(this, arguments);
            options.method = "delete";
            return Transport.ajax(options);
        }
    }, {
        key: "put",
        value: function put() {
            var options = this._normalizeArgs.apply(this, arguments);
            options.method = "put";
            return Transport.ajax(options);
        }
    }, {
        key: "patch",
        value: function patch() {
            var options = this._normalizeArgs.apply(this, arguments);
            options.method = "patch";
            return Transport.ajax(options);
        }
    }], [{
        key: "ajax",
        value: function ajax(options) {
            var transporter;

            if (_socket2.default.isAvailable()) {
                transporter = _socket2.default;
            } else {
                transporter = _ajax2.default;
            }

            return ransporter.send(options);
        }
    }]);

    return Transport;
})();

exports.default = Transport;