"use strict";

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _yargs = require("yargs");

var _yargs2 = _interopRequireDefault(_yargs);

var _repl = require("repl");

var _repl2 = _interopRequireDefault(_repl);

var _maya = require("../maya");

var _maya2 = _interopRequireDefault(_maya);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = function (args) {
    var options = _maya2.default.parseArgs(args);
    var cwd = process.cwd();
    var packageJsonPath = _path2.default.join(cwd, "package.json");
    var packageJson = require(packageJsonPath);
    var entry = _path2.default.join(cwd, packageJson.main ? packageJson.main : "app");
    var replServer;

    try {
        require(entry);

        if (options.interactive) {
            setTimeout(function () {
                replServer = _repl2.default.start({
                    prompt: "(๑>ヮ<)و✧> ",
                    useColors: true
                });
            }, 500);
        }
    } catch (e) {
        console.error("\u001b[31m[maya.js] Failed to load entry point\n");
        console.error(e.message, "\n", e.stack);
        console.error("\u001b[m");
        process.exit(-1);
    }
};