"use strict";

var _fsExtra = require("fs-extra");

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _glob = require("glob");

var _glob2 = _interopRequireDefault(_glob);

var _child_process = require("child_process");

var _yargs = require("yargs");

var _yargs2 = _interopRequireDefault(_yargs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports._copyBoilerplate = _copyBoilerplate;
module.exports.run = run;

function _copyBoilerplate(appDir) {
    var boilerplatePath = _path2.default.join(__dirname, "../../boilerplate/");
    var fromFiles = _glob2.default.sync(_path2.default.join(boilerplatePath, "**/{*,.gitkeep,.gitignore}"), { mark: true, nodir: true });

    if (!_fsExtra2.default.existsSync(appDir)) {
        _fsExtra2.default.ensureDirSync(appDir);
    }

    // Copy boilerplate files if does not exists in appDir
    fromFiles.forEach(function (fromPath) {
        var relatePath = fromPath.slice(boilerplatePath.length);
        var toPath = _path2.default.join(appDir, relatePath);

        if (!_fsExtra2.default.existsSync(toPath)) {
            _fsExtra2.default.copySync(fromPath, toPath);
        }
    });
}

function parseArgs(argv) {
    var parser = _yargs2.default.strict();

    return parser.parse(argv);
}

function run(argv) {
    var options = parseArgs(argv);

    var appDir = options._[0] ? _path2.default.join(process.cwd(), options._[0]) : process.cwd();
    var packageJsonPath = _path2.default.join(appDir, "package.json");

    // copy files
    console.log("\u001b[36m[maya.js] Generate project files.\u001b[m");
    _copyBoilerplate(appDir);

    // npm init
    var npmInitReuslt = (0, _child_process.spawnSync)("npm", ["init"], { stdio: "inherit", cwd: appDir });

    if (npmInitReuslt.status !== 0) {
        console.error("\u001b[31m[maya.js] package.json setup failed.\u001b[m");
        return;
    }

    console.log("\u001b[32m[maya.js] Setup successful.");
    console.log("  Execute \u001b[32;7m`npm install`\u001b[m\u001b[32m and Let's fight \u001b[32;7m`maya cqc`\u001b[m! ");
}