"use strict";

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _fs = require("fs");

var _fs2 = _interopRequireDefault(_fs);

var _eventKit = require("event-kit");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var FileWatcher = (function () {
    /**
     * @class FileWatcher
     * @constructor
     */

    function FileWatcher() {
        _classCallCheck(this, FileWatcher);

        this._watchers = new _eventKit.CompositeDisposable();
    }

    /**
     * @param {String} path
     * @param {Function(event: String, file: String)} callback
     * @return {Disposable}
     */

    _createClass(FileWatcher, [{
        key: "watch",
        value: function watch(path, callback) {
            var _this = this;

            var watcher = _fs2.default.watch(path, { persistent: true, recursive: true }, callback);
            watcher.on("error", function (err) {
                throw err;
            });

            var unwatch = new _eventKit.Disposable(function () {
                watcher.close();

                _this._watchers.remove(unwatch);
                unwatch = null;
            });

            this._watchers.add(unwatch);

            return unwatch;
        }
    }, {
        key: "unwatchAll",
        value: function unwatchAll() {
            this._watchers.dispose();
            this._watchers = new _eventKit.CompositeDisposable();
        }
    }]);

    return FileWatcher;
})();

exports.default = FileWatcher;