"use strict";

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
    value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var InMemorySessionStore = (function () {
    function InMemorySessionStore() {
        _classCallCheck(this, InMemorySessionStore);

        this._store = {};
    }

    _createClass(InMemorySessionStore, [{
        key: "get",
        value: function get(sid) {
            var sess = this._store[sid] = this._store[sid] || { timeout: null, store: {} };

            if (sess.timeout !== null && sess.timeout <= Date.now()) {
                return sess.store = {};
            }

            return Promise.resolve(sess.store);
        }
    }, {
        key: "set",
        value: function set(sid, store, ttlms) {
            var sess = this._store[sid] = this._store[sid] || { timeout: null, store: {} };

            sess.timeout = new Date(Date.now() + ttlms);
            sess.store = store;

            return Promise.resolve();
        }
    }, {
        key: "destroy",
        value: function destroy(sid) {
            delete this._store[sid];
            return Promise.resolve();
        }
    }]);

    return InMemorySessionStore;
})();

exports.default = InMemorySessionStore;