"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = reloaderInjector;
var contentTypeMatcher = /^text\/html/;
var bodyEndMatcher = /<\/body>/m;

var injectScript = "\n<script src=\"/socket.io/socket.io.js\" defer async></script>\n<script>\n(function () {\n    \"use strict\";\n\n    console.info(\"%c[maya.js]%c Waiting for load socket.io.js\", \"background-color:#00c3ed; color:#fff\", \"\");\n\n    var intervalId = setInterval(function () {\n        if (! window.io) { return; }\n        clearInterval(intervalId);\n        connect(window.io);\n    }, 0);\n\n    function connect(io) {\n        var socket = io.connect();\n\n        // use for resolve relative url to absolute url\n        var aEl = document.createElement(\"a\");\n\n        socket.on(\"connect\", function () {\n            console.info(\"%c[maya.js]%c Start watching assets changes.\", \"background-color:#00bbe3; color:#fff\", \"\");\n\n            socket.on(\"__maya__.swap\", function (change) {\n                if (change.fileType !== \"css\") { return; }\n                if (typeof document.querySelectorAll !== \"function\") { return; }\n\n                aEl.href = change.fileUrl;\n\n                var absoluteFileUrl = aEl.href;\n                var targetElements = [].slice.call(document.querySelectorAll(\"link[rel='stylesheet']\"), 0);\n                targetElements.forEach(function (el) {\n                    if (el.href.indexOf(absoluteFileUrl) === 0) {\n                        el.href = absoluteFileUrl + \"?\" + Date.now();\n                    }\n                });\n            });\n\n            socket.on(\"__maya__.reload\", function () {\n                // no using location.reload() for skip form repost.\n                location.href = location.href;\n            });\n        });\n    }\n}());\n</script>\n";

function reloaderInjector() {
    return function (req, res, next) {
        var end = res.end;

        // Override res.end
        res.end = function (chunk, encoding) {
            if (!chunk) {
                end.call(this, chunk, encoding);
                return;
            }

            var contentType = this.get("content-type");

            // if response finished or content-type isn't "text/html"
            // send chunk as it is.
            if (this.finished) {
                return end.call(this, chunk, encoding);
            }

            if (contentTypeMatcher.test(contentType) === false) {
                return end.call(this, chunk, encoding);
            }

            // Inject script
            var body = chunk.toString(encoding);
            var injectedBody;
            var buffer;

            if (bodyEndMatcher.test(body)) {
                injectedBody = body.replace(bodyEndMatcher, injectScript + "\n</body>");
            } else {
                injectedBody = body + injectScript;
            }

            buffer = new Buffer(injectedBody, encoding);
            encoding = undefined;

            this.set("Content-Length", buffer.length);
            end.call(this, injectedBody, encoding);
        };

        res._end = end;
        next();
    };
}