"use strict";

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _lodash = require("lodash");

var _lodash2 = _interopRequireDefault(_lodash);

var _waterline = require("waterline");

var _waterline2 = _interopRequireDefault(_waterline);

var _extend = require("./utils/extend");

var _extend2 = _interopRequireDefault(_extend);

var _swappable = require("./swappable");

var _swappable2 = _interopRequireDefault(_swappable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Model = (function (_Swappable) {
    _inherits(Model, _Swappable);

    function Model() {
        _classCallCheck(this, Model);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(Model).apply(this, arguments));
    }

    _createClass(Model, [{
        key: "toWaterlineCollection",

        /**
         * @property {}
         */

        /**
         * Transform Model to Waterline.Collection
         * @param {Object} props method and properties for assignes collection.attributes
         * @param {Object} staticProps method and properties for assignes collection (static).
         * @return {Waterline.Collection}
         */
        value: function toWaterlineCollection() {
            var props = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
            var staticProps = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

            var schema = {};

            _lodash2.default.defaults(schema, {
                identity: this.identity,
                schema: this.schema,
                tableName: this.tableName,
                connection: this.connection,
                attributes: this.attributes
            }, {
                identity: staticProps.identity,
                schema: null,
                tableName: null,
                connection: "default",
                attributes: {}
            });

            delete staticProps.identity;

            _lodash2.default.extend(schema.attributes, props);
            _lodash2.default.extend(schema, staticProps);

            return _waterline2.default.Collection.extend(schema);
        }
    }], [{
        key: "create",
        value: function create(proto) {
            var Child = (0, _extend2.default)(proto, Model);
            return new Child();
        }
    }]);

    return Model;
})(_swappable2.default);

exports.default = Model;