"use strict";

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _fs = require("fs");

var _fs2 = _interopRequireDefault(_fs);

var _swappable = require("./swappable");

var _swappable2 = _interopRequireDefault(_swappable);

var _prettyLog = require("./utils/pretty-log");

var _prettyLog2 = _interopRequireDefault(_prettyLog);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ModuleSwapper = (function () {

    /**
     * @property {Object<string, fs.FSWatcher>} watcher
     */
    // watcher;

    /**
     * @property {Object} options
     * @property {Logger} options.logger
     */
    // options;

    /**
     * @property {Logger} logger
     */

    function ModuleSwapper(options) {
        _classCallCheck(this, ModuleSwapper);

        this.watcher = {};
        this.options = options;
        this.logger = options.logger;
    }

    _createClass(ModuleSwapper, [{
        key: "require",
        value: (function (_require) {
            function require(_x, _x2) {
                return _require.apply(this, arguments);
            }

            require.toString = function () {
                return _require.toString();
            };

            return require;
        })(function (modulePath, callerRequire) {
            callerRequire = callerRequire || require;

            try {
                var fullPath = callerRequire.resolve(modulePath);

                if (this.options.watch === true) {
                    this.registerWatcher(fullPath);
                }

                return callerRequire(fullPath);
            } catch (e) {
                throw new Error("Module loading failed for '" + modulePath + "'. (" + e.message + ")");
            }
        })

        // watch (path, callback) {
        //     fs.watch(path, callback);
        // }

    }, {
        key: "swapModule",
        value: function swapModule(fullPath) {
            var cache = require.cache[fullPath];

            if (!this.isSwappableModuleCache(cache)) {
                return;
            }

            cache.exports._dispose();
            delete require.cache[fullPath];
            require(fullPath);

            this.logger.info("ModuleSwapper", "swapped module %s", fullPath);
        }
    }, {
        key: "isSwappableModuleCache",
        value: function isSwappableModuleCache(cache) {
            if (!cache) {
                return false;
            }
            if (cache.hasOwnProperty("exports") === false) {
                return false;
            }
            if (cache.exports instanceof _swappable2.default === false) {
                return false;
            }
            return true;
        }
    }, {
        key: "registerWatcher",
        value: function registerWatcher(fullPath) {
            var _this = this;

            if (this.watcher[fullPath]) {
                return;
            }

            this.logger.verbose("ModuleSwapper", "start watching : %s", fullPath);

            this.watcher[fullPath] = _fs2.default.watch(fullPath, function (event, filename) {
                switch (event) {
                    //    case "rename":
                    //         fullPath = filename;
                    //     //    this.watcher[filename] = this.watcher[fullPath];
                    //        break;

                    case "change":
                        _this.swapModule(fullPath);
                        break;
                }
            });
        }
    }]);

    return ModuleSwapper;
})();

exports.default = ModuleSwapper;