"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.get = get;
exports.set = set;

function _typeof(obj) { return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj; }

var hasOwnProperty = ({}).hasOwnProperty;

function get(obj, key, defaults) {
    if (key == null) {
        return obj;
    }

    var keys = key.split(".");
    var pt = obj;
    var current;

    while (current = keys.shift()) {
        if (keys.length !== 0 && ((typeof pt === "undefined" ? "undefined" : _typeof(pt)) !== "object" || !hasOwnProperty.call(pt, current))) {
            return defaults;
        }

        pt = pt[current];
    }

    return pt;
}

function set(obj, key, value) {
    var keys = key.split(".");
    var lastKey = keys.pop();
    var pt = obj;
    var current;

    while (current = keys.shift()) {
        if ((typeof pt === "undefined" ? "undefined" : _typeof(pt)) !== "object" || !hasOwnProperty.call(pt, current)) {
            pt[current] = {};
        }
    }

    pt[lastKey] = value;
}