"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = extend;

var _lodash = require("lodash");

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @function extend
 * @param {Object} SubClass SubClass constructor or prototype Object
 * @param {Function} SuperClass Constructor of super class
 */
function extend(proto, SuperClass) {
    var SubClass = typeof proto === "function" ? proto : function () {
        SuperClass.apply(this, arguments);
    };

    if (typeof proto === "function") {
        var _proto = SubClass.prototype;
        SubClass.prototype = Object.create(SuperClass.prototype);
        _lodash2.default.assign(SubClass.prototype, _proto);
    } else {
        SubClass.prototype = Object.create(SuperClass.prototype);
        _lodash2.default.assign(SubClass.prototype, proto);
    }

    return SubClass;
};