"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.error = error;

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _stackTrace = require("stack-trace");

var stackTrace = _interopRequireWildcard(_stackTrace);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function error(title, error) {
    var stackList = stackTrace.parse(error);
    var basePath = process.cwd();

    var stringifyStack = stackList.map(function (stack, idx) {
        var methodName = stack.methodName ? stack.methodName : stack.functionName;
        var fileName = stack.fileName ? _path2.default.parse(stack.fileName).base : "";
        var filePath = stack.fileName ? stack.fileName.replace(basePath, "") : "";

        if (stack.native) {
            return "\u001b[31;1m  #" + (stackList.length - idx) + " " + stack.functionName + " \u001b[m\u001b[31m(native)\n" + ("\u001b[34m    at Line: " + stack.lineNumber + " Column: " + stack.columnNumber);
        } else {
            return "\u001b[31;1m  #" + (stackList.length - idx) + " " + fileName + " \u001b[m\u001b[31m(" + filePath + ")\n" + ("\u001b[34m    at " + methodName + "(" + stack.typeName + ")") + ("\tLine: " + stack.lineNumber + " Column: " + stack.columnNumber);
        }
    }).join("\n");

    console.error("\u001b[31m====== " + title + "\n" + ("Message\t\t:\n  \u001b[31;1m" + error.message + "\n") + "\u001b[m\u001b[31m" + ("Stack trace\t:\n" + stringifyStack + "\n\u001b[31m") + "============\u001b[m\n");
};